
import Sudoku
import Control.Parallel.Strategies ( rpar, rseq, runEval )
import Control.DeepSeq
import Data.Maybe(isJust)

main :: IO ()
main =do sudos <- lines <$> readFile "sudoku17.1000.txt"
         let [as,bs,cs] = splitList 3 sudos
             solutions = runEval $ do
                as' <- rpar (force (map solve as))
                bs' <- rpar (force (map solve bs))
                cs' <- rpar (force (map solve cs))
                _ <- rseq as'
                _ <- rseq bs'
                _ <- rseq cs'
                return (as' ++ bs' ++ cs')
         print (length (filter isJust solutions))